<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: /home/mohamed/code/tigl/src/standard/benchmark/tiglBenchmarkVertexDijkstra.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_512e97a87e29490d503e7e4403f25482.html">standard</a></li><li class="navelem"><a class="el" href="dir_c8a6b44b51a505c59ee83482c1b4fd3c.html">benchmark</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglBenchmarkVertexDijkstra.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglBenchmarkVertexDijkstra_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef VERTEXDIJKSTRA_HPP_</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define VERTEXDIJKSTRA_HPP_</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;tiglContainersVertexBase.hpp&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;tiglPregelMacros.h&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;tiglBenchmarkGraphStruct.h&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DIST_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="structNODE__Dijkstra.html">   30</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structNODE__Dijkstra.html">NODE_Dijkstra</a>{</div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="structNODE__Dijkstra.html#a17805df41ff1dfdef2c73e2cebafca11">   32</a></span>&#160;    DIST_TYPE <a class="code" href="structNODE__Dijkstra.html#a17805df41ff1dfdef2c73e2cebafca11">distance</a>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="structNODE__Dijkstra.html#a383d0d27ef215df31a93fedb0b403f9e">   35</a></span>&#160;    ID_TYPE <a class="code" href="structNODE__Dijkstra.html#a383d0d27ef215df31a93fedb0b403f9e">parent</a>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;};</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType = <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span>&gt;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">class </span>vertexDijkstra:</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">public</span> <a class="code" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt;DataType, NODE_Dijkstra&lt;typename EdgeType::DATA_TYPE, IdType&gt;, EdgeType, IdType&gt;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;{</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">typedef</span> <a class="code" href="structNODE__Dijkstra.html">NODE_Dijkstra&lt;typename EdgeType::DATA_TYPE, IdType&gt;</a> ALG_DATA_TYPE;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    vertexDijkstra(IdType key) : <a class="code" href="classVertexBase.html">TIGLContainersVertexBase&lt;DataType, ALG_DATA_TYPE, EdgeType, IdType&gt;</a>(key) {}</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    ~vertexDijkstra(){}</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    COLOR color;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">void</span> init(){</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="comment">/*initializing the algData field and calling the base initialization function*/</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        this-&gt;<a class="code" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a>.<a class="code" href="structNODE__Dijkstra.html#a383d0d27ef215df31a93fedb0b403f9e">parent</a> = ILLEGAL_NODE;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        this-&gt;<a class="code" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a>.<a class="code" href="structNODE__Dijkstra.html#a17805df41ff1dfdef2c73e2cebafca11">distance</a> = BIG_DBL_NUMBER;<span class="comment">//LARGE_NUMBER;</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <a class="code" href="classVertexBase.html">TIGLContainersVertexBase&lt;DataType, ALG_DATA_TYPE, EdgeType, IdType&gt;::init</a>();</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    }</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordtype">void</span> init_src(){</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="comment">/*initializing the algData field and calling the base initialization function*/</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        this-&gt;<a class="code" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a>.<a class="code" href="structNODE__Dijkstra.html#a383d0d27ef215df31a93fedb0b403f9e">parent</a> = ILLEGAL_NODE;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        this-&gt;<a class="code" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a>.<a class="code" href="structNODE__Dijkstra.html#a17805df41ff1dfdef2c73e2cebafca11">distance</a> = 0;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        color = WHITE;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <a class="code" href="classVertexBase.html">TIGLContainersVertexBase&lt;DataType, ALG_DATA_TYPE, EdgeType, IdType&gt;::init</a>();</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    }</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">bool</span> compute(<span class="keywordtype">void</span> * pIn = 0, <span class="keywordtype">void</span> * pOut = 0) {</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        ALG_DATA_TYPE * p = (ALG_DATA_TYPE * )pIn;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">if</span>((p-&gt;distance) &lt; this-&gt;<a class="code" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a>.<a class="code" href="structNODE__Dijkstra.html#a17805df41ff1dfdef2c73e2cebafca11">distance</a>)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        {</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            this-&gt;<a class="code" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a> = *p;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        }</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    }</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keywordtype">void</span>  changeColor(){</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordflow">switch</span>(color){</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordflow">case</span> WHITE: color = GRAY; <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keywordflow">case</span> GRAY: color = PSEUDO_BLACK; <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <span class="keywordflow">case</span> PSEUDO_BLACK: color = BLACK; <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordflow">case</span> BLACK:</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        }</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    }</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    COLOR getColor(){<span class="keywordflow">return</span> color;}</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;};</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* VERTEXDIJKSTRA_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="structNODE__Dijkstra_html"><div class="ttname"><a href="structNODE__Dijkstra.html">NODE_Dijkstra</a></div><div class="ttdef"><b>Definition:</b> tiglBenchmarkVertexDijkstra.hpp:30</div></div>
<div class="ttc" id="structNODE__Dijkstra_html_a383d0d27ef215df31a93fedb0b403f9e"><div class="ttname"><a href="structNODE__Dijkstra.html#a383d0d27ef215df31a93fedb0b403f9e">NODE_Dijkstra::parent</a></div><div class="ttdeci">ID_TYPE parent</div><div class="ttdef"><b>Definition:</b> tiglBenchmarkVertexDijkstra.hpp:35</div></div>
<div class="ttc" id="structNODE__Dijkstra_html_a17805df41ff1dfdef2c73e2cebafca11"><div class="ttname"><a href="structNODE__Dijkstra.html#a17805df41ff1dfdef2c73e2cebafca11">NODE_Dijkstra::distance</a></div><div class="ttdeci">DIST_TYPE distance</div><div class="ttdef"><b>Definition:</b> tiglBenchmarkVertexDijkstra.hpp:32</div></div>
<div class="ttc" id="classVertexBase_html"><div class="ttname"><a href="classVertexBase.html">TIGLContainersVertexBase</a></div><div class="ttdoc">core Vertex class that contains all the vertex data and defines all vertex mutations It is a template...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:43</div></div>
<div class="ttc" id="classVertexBase_html_a1194c063341fb9886a4836d30baaec86"><div class="ttname"><a href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">TIGLContainersVertexBase&lt; DataType, NODE_Dijkstra&lt; EdgeType::DATA_TYPE, IdType &gt;, EdgeType, IdType &gt;::algData</a></div><div class="ttdeci">NODE_Dijkstra&lt; EdgeType::DATA_TYPE, IdType &gt; algData</div><div class="ttdoc">Algorithm-specific data. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:78</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Oct 20 2014 16:19:13 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
